// -*- C++ -*-
/*!
 * @file DirectInPortBase.h
 * @brief DirectInPortBase class
 * @date $Date: 2018-1-23 03:08:05 $
 * @author Nobuhiko Miyamoto <n-miyamoto@aist.go.jp>
 *
 * Copyright (C) 2018
 *     Nobuhiko Miyamoto
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 *
 */

#ifndef RTC_DIRECTINPORTBASE_H
#define RTC_DIRECTINPORTBASE_H



#include <coil/Mutex.h>
#include <rtm/DirectPortBase.h>



namespace RTC
{
	/*!
	* @if jp
	* @class DirectInPortBase
	* @brief direct³InPort쥯饹
	*
	*
	* @since 1.2.0
	*
	* @else
	* @class DirectOutPortBase
	* @brief
	*
	*
	*
	* @since 1.2.0
	*
	* @endif
	*/
  template <class DataType>
  class DirectInPortBase : public DirectPortBase
  {
  public:
	  /*!
	  * @if jp
	  * @brief 󥹥ȥ饯
	  *
	  * @param value
	  *
	  * @else
	  * @brief Constructor
	  *
	  * @param value
	  *
	  * @endif
	  */
    DirectInPortBase(DataType& value)
    {
    }
    
	/*!
	* @if jp
	* @brief ǥȥ饯
	*
	*
	* @else
	* @brief Destructor
	*
	*
	* @endif
	*/
    virtual ~DirectInPortBase(void){};



    
    /*!
     * @if jp
     *
     * @brief ǿǡ¸ߤ뤫ǧ
     * 
     * InPort̤ɤκǿǡ夷Ƥ뤫bool֤ͤ
     * InPort̤³ξ硢³ͥΥХåեEmpty
     * ξˤfalse֤
     *
     * @return true ̤ɤκǿǡ¸ߤ
     *         false ̤³ޤϥХåե˥ǡ¸ߤʤ
     * 
     * @else
     *
     * @brief Check whether the data is newest
     * 
     * Check whether the data stored at a current buffer position is newest.
     *
     * @return Newest data check result
     *         ( true:Newest data. Data has not been readout yet.
     *          false:Past dataData has already been readout.)
     * 
     * @endif
     */
    virtual bool isNew()
    {
		return false;
    }

    /*!
     * @if jp
     *
     * @brief Хåեɤǧ
     * 
     * InPortΥХåեɤ bool ֤ͤ
     * ξ true, ̤ɥǡ false ֤
     *
     * @return true  Хåե϶
     *         false Хåե̤ɥǡ
     * 
     * @else
     *
     * @brief Check whether the data is newest
     * 
     * Check whether the data stored at a current buffer position is newest.
     *
     * @return Newest data check result
     *         ( true:Newest data. Data has not been readout yet.
     *          false:Past dataData has already been readout.)
     * 
     * @endif
     */
    virtual bool isEmpty()
    {
		return true;
    }

	/*!
	* @if jp
	* @brief ǡν񤭹
	*
	* @param data ǡ
	*
	* @else
	* @brief
	*
	* @param data
	*
	* @endif
	*/
    virtual void write(const DataType& data)
    {
    }


  protected:
    

  };
}; // End of namesepace RTM

#endif // RTC_DIRECTINPORTBASE_H
